"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Corners = void 0;
const Corner_js_1 = require("./Corner.js");
/**
 * The representation of all neighbors of a cell
 */
class Corners {
    grid;
    sourceCell;
    /**
     * @param grid The grid the cell is part of
     * @param sourceCell The source cell
     */
    constructor(grid, sourceCell) {
        this.grid = grid;
        this.sourceCell = sourceCell;
    }
    /**
     * @param direction The direction to the corner
     * @returns The corner
     */
    get(direction) {
        const neighborCells = this.getNeighborDirections(direction)
            .map((direction) => this.sourceCell.neighbors.find(direction))
            .filter(Boolean);
        return new Corner_js_1.Corner(this.sourceCell, direction, neighborCells);
    }
}
exports.Corners = Corners;
