import type { Grid } from './Grid.js';
import type { Cell } from './Cell.js';
import { Corner } from './Corner.js';
import type { Directions } from './Directions.js';
/**
 * The representation of all neighbors of a cell
 */
export declare abstract class Corners<TValue, TDirections extends Directions, TCell extends Cell<TValue, TDirections>> {
    protected grid: Grid<TValue, TDirections, TCell>;
    protected sourceCell: TCell;
    /**
     * @param grid The grid the cell is part of
     * @param sourceCell The source cell
     */
    constructor(grid: Grid<TValue, TDirections, TCell>, sourceCell: TCell);
    /**
     * @param direction The direction to the corner
     * @returns The corner
     */
    get(direction: TDirections['Corner']): Corner<TValue, TDirections, TCell>;
    protected abstract getNeighborDirections(cornerDirection: TDirections['Corner']): TDirections['Neighbor'][];
}
